/*********************************************************************
{\[XXgу\tgEFÁACZXt[łB
pAҏWAĔzzRɍs܂A쌠\̉ς͋֎~܂B

                               Copyright (c) 2009-2010 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/

//	ԊORM\tgEFA
//
//		Copyright (c) 2009-2010 Wataru KUNINO
//
//			gp}CR	PIC12F683
//			RpC@	HI-TECH Software PICC PRO 9.60

#include <htc.h>
    __CONFIG(INTIO & WDTDIS & PWRTDIS & MCLRDIS & UNPROTECT & BORDIS & IESODIS & FCMDIS);
#include "scif.h"

//#define DIAG						// fobOp
#define _XTAL_FREQ	8000000	
#define RF_LEN		53				// ^C}[p g
#define RF_DUTY		30				// ^C}[p f[eB[
#define RF_WAIT		30				// ̑MԊuƂȂ҂(10ms̔{)
#define IR_OUT		GPIO4			// ԊOLED̐ڑ|[g
#define IR_OUT_OFF	0x00			// ԊOLED񔭌̏o͒l
#define IR_OUT_ON	0x01			// ԊOLED̏o͒l
#define LED_OUT		GPIO5			// LED̐ڑ|[g
#define DATA_SIZE	8				// f[^(byte),4̔{
#define DATA_LEN	48				// f[^(bit),8̔{ PICp
#define DATA_NUM	3				// f[^(ԊOR}h)
#define ADC_KEY_V	4900			// ADCL[p̓d[mV]
#define ADC_KEY_M	2245			// ADCL[16ԃ{^̓d[mV]
#define ADC_LOOP	0x01			// `^Oh~̂߂ADCǂݎ
#define ADC_KEY_MB	117
#define ADC_KEY_HLB	4

#ifndef FLASH_DEF
	#define FLASH_DEF
	#define FLASH_AEHA_TIMES	18	// V{Ԃ̓_ŉ񐔁i`dg`j
//	#define FLASH_NEC_TIMES	22	// V{Ԃ̓_ŉ񐔁imdbj
//	#define FLASH_SIRC_TIMES	24	// V{Ԃ̓_ŉ񐔁irhqbj
#endif

/* O[oϐ RM */
unsigned char data[DATA_NUM][DATA_SIZE]={
	{0xAA,0x5A,0x8F,0x12,0xC4,0x21},	// AQUOS MENU (AEHA len=48)
	{0xAA,0x5A,0x8F,0x12,0x15,0xE1},	// AQUOS TV VOL_DOWN
	{0xAA,0x5A,0x8F,0x12,0x14,0xF1},	// AQUOS TV VOL_UP
};
	
struct adc_result{
	char value;				// ADC built-in functions default to 8 bit result.
	unsigned new_flag:1;	// 1-bit flag to indicate a new (fresh) value
} adc_conversion;

void init_io(void);							// |[gݒ
void init_ir(void);							// ԊOݒ
void init_ir_off(void);
void init_adc(void);						/* ADCݒ */
void init_adc_off(void);
void interrupt interrupt_service(void);		/* ADC */
char adc_key(void);							/* ADCL[ */
char adc_key_char(char in);					/* ADCL[ϊ */
void ir_flash(unsigned char times);			// ԊO̓_(38kHz)
void ir_wait(unsigned char times);			// ԊȌ
void ir_send_simple(unsigned char ir_id);	// ԊOM
void main(void);							// C

/* |[gݒ */
void init_io(void){
	// PIC12F683
	// 		pin 1	Vcc
	// 		pin 2	GPIO5 Output(LED=Green)
	// 		pin 3	GPIO4 Output(IR_LED)
	// 		pin 4	GPIO3 Input (test KEY)
	// 		pin 5	GPIO2 Timer Output
	// 		pin 6	GPIO1 Output SCI
	// 		pin 7	GPIO0 ADC Input
	// 		pin 8	GND

	GPIO    = 0b00000010;
	CMCON0  = 0b00000111;	// Comparator Off
	ANSEL   = 0x00;			// ADC Off
	GPPU    = 0;	// bit 0 = GPIO Pull-up Enable  1 = disabled
	WPU0    = 0;	// bit 1 = pull up
	WPU1    = 0;
	WPU2    = 0;	// TIMERo
	WPU3    = 0;
	WPU4    = 0;
	WPU5    = 0;
	TRISIO0 = 1;	// bit 0 = output, 1 = input
	TRISIO1 = 0; 
	TRISIO2 = 0;	// TIMER2Ɏgp
//	TRISIO3 = 1;	// inputŒ
	TRISIO4 = 0;
	TRISIO5 = 0;
}

/* IRݒ ^C}[QA|[gQ̎gp*/
void init_ir(void){
	OSCCON  = 0b01110000;	// Clock =8MHz
	
	//	TIMER2 8-bit (GPIO2)
	//	(Pre-scaler x1 )	Clock = 8MHz/4
	//	AEHA,NEC	38kHz	-> PR2 = 53(37.75kHz)
	PR2 = RF_LEN;			// 53(37.75kHz)
	CCPR1L	= RF_DUTY;		// 30(Duty)
	CCP1CON	= 0b00001100;
	//		      |||__|__ 1100 = PWM Mode
	//		      ||______ PWM Duty Cycle Least Significant
	T2CON	= 0b00000100;
	//		     |  ||||__ Prescaler
	//		     |  ||____ TMR2ON 
	//		     |__|_____ Postscaler
}
void init_ir_off(void){
	T2CON	= 0b00000000;
	//		     |  ||||__ Prescaler
	//		     |  ||____ TMR2 off
	//		     |__|_____ Postscaler
}

/* ADCݒ |[gOA荞ݏ*/
void init_adc(void){		// Set up RA0 as the only analog input
	ANSEL  = 0b00000001;	// ANS0=1 AN0 (RA0) analog
	ADFM   = 0;				// Result Format : justfified 0=left=0, 1=right
	VCFG   = 0;				// Voltage Reference bit : 1=VREF, 0=VDD
	ADON   = 1;				// ADC Enable bit 1=enabled 0=disabled
	GODONE = 1;				// start the first conversion
	// TIMER0 for ADC
	OPTION = 0b10000111;	// configure Timer0
	T0IF = 0;				// ensure Timer0 Interrupt flag is clear
	T0IE = 1;				// enable Timer0 interrupts
}
void init_adc_off(void){
	T0IE = 0;				// disable Timer0 interrupts
	GODONE = 0;				// stop the conversion
	ADON   = 0;				// ADC Enable bit 1=enabled 0=disabled
}

/* ݏ */
void interrupt interrupt_service(void){
	if (T0IE && T0IF){					// Timer0 Interrupt (channel = AN0)
		adc_conversion.value = ADRESH;	// Get last conversion result. (8 MSBs)
		adc_conversion.new_flag = 1;	// new value
		GODONE = 1;						// start next conversion
		T0IF = 0;						// clear Timer0 interrupt flag
	}
	TMR1IF = 0;
}

/* ADCL[{[h */
char adc_key(void){
	unsigned char in = 0x00;
	unsigned char prev = 0x00;						//{̏l̓[v
	unsigned char loop = ADC_LOOP;
	
	while( loop ){
		loop--;
		while(adc_conversion.new_flag == 0);		// ADC͑҂
		in = adc_conversion.value;
		adc_conversion.new_flag = 0;
		if( (in-1) > prev || (in+1) < prev ){
			loop = ADC_LOOP;						// lϓ̂ŕs
			while(adc_conversion.new_flag == 0);	// ADC͑҂
			prev = adc_conversion.value;			// l
			adc_conversion.new_flag = 0;
		}
	}
	if( in < ADC_KEY_HLB || in > (ADC_KEY_MB + ADC_KEY_HLB ) ){
		return( 0 );
	}else{
		return( (char)(( 16*(unsigned int)(in + ADC_KEY_HLB)) / (unsigned int)ADC_KEY_MB) );
													// ߂l1`16̃L[ԍ ܂ ͂ȂO
	}
}

char adc_key_char(char in){
	if( in >= 0x01 && in <= 0x03 ) return( in + '0' );
	if( in >= 0x05 && in <= 0x07 ) return( in-1 + '0' );
	if( in >= 0x09 && in <= 0x0B ) return( in-2 + '0' );
	switch( in ){
		case 0x0D:
			return( '*' );
			//break;
		case 0x0E:
			return( '0' );
			//break;
		case 0x0F:
			return( '#' );
			//break;
		case 0x04:
			return( 'A' );
			//break;
		case 0x08:
			return( 'B' );
			//break;
		case 0x0C:
			return( 'C' );
			//break;
		case 0x10:
			return( 'D' );
			//break;
	}
	return( 'E' );
}

/* ԊOkdc_ŗp(^C}[p) */
void ir_flash(unsigned char times){
	unsigned char i = times * FLASH_AEHA_TIMES;
	
	while(i){
		IR_OUT = IR_OUT_ON;
		i--;
		while( GPIO2 ==0x01 );
		IR_OUT = IR_OUT_OFF;
		while( GPIO2 ==0x00 );
	}
}

void ir_wait(unsigned char times){
	unsigned char i = times * FLASH_AEHA_TIMES;
	
	while(i){
		IR_OUT = IR_OUT_OFF;
		i--;
		while( GPIO2 ==0x01 );
		IR_OUT = IR_OUT_OFF;
		while( GPIO2 ==0x00 );
	}
}

/* ԊOkdcMo */
void ir_send_simple(unsigned char ir_id){
	int i;
	int data_bit;
	int data_len = DATA_LEN;

	unsigned char out;
	
	//	case AEHA:
	ir_flash(0x08);						// send 'SYNC'
	ir_wait(0x04);							// send 'SYNC'
	for(i=0;i<DATA_SIZE;i++){
		out = data[ir_id][i];
		for(data_bit=0;data_bit<8;data_bit++){
			ir_flash(0x01);
			if( ((out)&(1)) == 0){
				ir_wait(0x01);
			}else{
				ir_wait(0x03);
			}
			data_len--;
			if( data_len == 0){
				i = DATA_SIZE -1;
				data_bit=7;
			}
			out >>= 1;
		}
	}
	ir_flash(1);						// send 'stop'
}

void main(){
	unsigned char in, value;
	unsigned char count = RF_WAIT;
	int i;
	
	adc_conversion.value = 0;
	adc_conversion.new_flag = 0;

	init_io();
	LED_OUT = 1;					// LED_
	IR_OUT = IR_OUT_OFF;			// M̋It
	scif_init();					// VA
	init_ir();						// Clock =8MHz Port2=TIMERQo
	init_adc();
	ei();					// enable global interrupts
	
	__delay_ms(10);
	puts("IR TX\n");
	puts("by Wataru Kunino\n");
	LED_OUT = 0;					// LED

	while(1) {
		in = 0xFF;
		while(in == 0xFF){
			if( GPIO3 == 0 ){
				in = 0x01;			// GPIO 2 ID=2
				putch( 'K' );
			}
			if( in == 0xFF ){
				in = adc_key();
				in = adc_key_char(adc_key());
				if( in == 'D' ){
					puts("\\\n");
				}else if( in !='E' ){
					putch( in );
				}
				switch( in ){
					case '1':
						in = 0x01;
						break;
					case '2':
						in = 0x02;
						break;
					case '3':
						in = 0x00;
						break;
					case 'E':
						in = 0xFF;
						break;
					default :
						in = 0xFF;
						break;
				}
			}
		}
		/* RM */
		LED_OUT = 1;					// ͑҂LED_
		ir_send_simple( in );
		IR_OUT = IR_OUT_OFF;			// M̋It
		LED_OUT = 0;
		/* M̑҂ */
		for(count=RF_WAIT; count>0;count--) __delay_ms(10);
	}
} 
